#if !defined (OGFILTERS_H)
#define OGFILTERS_H

#include "defs.h"
#include "math.h"

class spigolo_e_tor {
	public:
	int spigolo;
	torsione tor;
	spigolo_e_tor(int s=0, torsione t=0):spigolo(s), tor(t) {}
	
};

void scrivi(const std::vector<std::vector<std::list<std::list<spigolo_e_tor> > > >& ris);
void scrivi(const std::list<spigolo_e_tor>& fi);
bool operator<(const spigolo_e_tor& st1, const spigolo_e_tor& st2);
void aggiungi(std::vector<std::vector<std::list<std::list<spigolo_e_tor> > > >& ris, std::list<spigolo_e_tor> nuova);
std::vector<std::vector<std::list<std::list<spigolo_e_tor> > > > filtri_brick(const igrafo&);
void cappello (int j1, int c1, int j2, int c2, int k, int ck, int h, int ch, int* tor, int* c);
void set_paths(std::vector<int>& ent, std::vector<int>& usc, std::vector<int>& vert, int liv, int lati, 
							 const igrafo& ig, std::vector<std::vector<std::list<std::list<spigolo_e_tor> > > >& ris,
							 const tensor2& n_spigolo);
void set_ciclo(std::vector<int>& ent, std::vector<int>& usc, const std::vector<int>& vert, int liv, int lati, 
							 const igrafo& ig, std::vector<std::vector<std::list<std::list<spigolo_e_tor> > > >& ris,
							 const tensor2& n_spigolo);

torsione maschera (int usc, int col, int usc2, int col2);
void ciclo (const std::vector<int>& usc, const std::vector<int>& ent, std::vector<torsione>& tor, 
						std::vector<int>& pos, int nv);
torsione Cforza (int* c1, int* c2, int* c3, int* c4, int cf1, int cf2);
void cappello (int j1, int c1, int j2, int c2, int k, int ck, int h, int ch, 
							 std::vector<torsione>& tor, std::vector<int>& c);

void test_restrizioni(const ografo& o);



#endif
