#if !defined (IGRAPH_H)
#define IGRAPH_H

#include "defs.h"
#include "graph.h"

class igrafo:public grafo{
 public:
  igrafo():grafo() {}
  igrafo(const igrafo& ig);
  igrafo(const grafo& g, const std::vector<int>&);
  
  igrafo& operator=(const igrafo& ig);
  virtual ~igrafo() {}
  virtual igrafo* clone() const {return new igrafo(*this);}

  //sovrascritta:
  virtual void scrivi(std::ostream& f, int tipo_formato = 0) const;
  virtual bool operator<(const grafo& y) const;
  
  //nuove:
  int    get_col(int i, int j) const {return v[i]->get_col(j);}
  void set_col(int i, int j, int i2, int j2, torsione tr = 0);

  void C(int vert, int tipo, int inverso=0);
	void C(const std::vector<int>& );
  void specchio ();

  std::vector<int> minimizza_con_C();
  std::vector<int> mosse_C_minimizzanti () const;

  //sovrascritte:
  virtual void trasforma (const trasformazione&);
  virtual trasformazione trasformazione_banale() const;
  virtual std::list<trasformazione> trasformazioni_minimizzanti(bool fermati_subito = FALSE) const;

  int v2spigolo (int, int) const;
  void spigolo2v (int, int&, int&) const;
  bool prima_occorrenza_spigolo(int vert, int usc) const;

  //hanno effetto solo con *v[i]==overtice:
  void tor_add(int i, int j, int k);
  void tor_invert(int i, int j);
  torsione get_tor(int i, int k) const {return v[i]->get_tor(k);}
  void set_tor(int i, int j, torsione tr);

 protected:
  virtual void Cz(int vert, const int* z, int delta_tor=0);

 private:
  void R(int vert);
  void mosse_C_minimizzanti (int, std::vector<int>&) const;
};

class ivertice:public vertice {
 protected:
  int col[4];
 public:
  ivertice();
  ivertice(const vertice& v, const int* cl);
  int get_col(int i) const {return col[i];}
  void set_col(int i, int cl) {col[i]=cl;}
  
	virtual ~ivertice() {}
  virtual ivertice* clone() const {return new ivertice(*this);}
  virtual bool operator==(const vertice& y) const;
};

std::list<igrafo> crea_igrafi(const grafo& g);

tensor2 mosse_C (const igrafo& x, const igrafo& y);

int effetto_C_su_tor(int tipo, int inverso=FALSE);

bool trasformazione_banale(const tensor2&);


#endif
