#if !defined( __OGMATH_H )
#define __OGMATH_H

int mod (int a, int b); 
long modl (long a, long b);
long fact (int);
void perm_ciclicamente (int*, int, int);   //permuta ciclicamente
void perm (int *, int, long);
std::vector<int> perm_inversa (const std::vector<int>&);
void ordina (int *, int);
void ordina_ciclicamente (int*, int);
void un_ciclo(int*, int);
int segno (const int *); //ritorna il segno della permutazione di 4 elementi data da (v[0],v[1],v[2],v[3])
int ordine (const int *);    //ritorna l'ordine della permutazione di 4 elementi data da (v[0],v[1],v[2],v[3])
void inverti (int *);
void lettera (int, char*);
int norma(int, int);       //per coprime integers, con |1,0|=|1,1|=|0,1|=0 come definita in articolo
int ctoi (char*, int=0);
bool rapporti_uguali (int, int, int, int);
unsigned long MCD(unsigned long, unsigned long);
long double abs(long double);
double abs(double);
std::vector<int> abs(const std::vector<int>&);
unsigned int MCD(int, int);
unsigned int mcm(int, int);
int phi(int);

class intervallo {
 public:
  int a;
  int b;
  intervallo (const intervallo& I): a(I.a),b(I.b) {}
  intervallo (int aa,int bb):a(aa),b(bb) {}
  intervallo (int i):a(i),b(i) {}
  intervallo (bool, char*, bool, bool, bool);
  bool contiene(int);
  bool tutto() {return ((a==0)*(b==-1));}
  bool vuoto() {return ((b<a) && (b!=-1));}
  bool punto() {return (b==a);}
  void interseca (intervallo);
};

const intervallo vuoto = intervallo(1,0);

#endif
